﻿# default hero = inventory_class(
#     "You",
#     223,
#     [
#         bronze_chestplate,
#         iron_chestplate,
#         engraved_chestplate,
#         steel_chestplate,
#         ancient_armor,

#         iron_shoes,
#         leather_shoes,

#         golden_gloves,
#         half_gloves,
#         royal_gloves,

#         bronze_helmet,
#         engraved_helmet,
#         golden_helmet,
#         horny_hood,
#         rain_collector_helmet,
#         royal_helmet,
#         rusty_helmet,

#         dual_lion_shield,
#         lion_shield,
#         round_shield,
#         sun_shield,
#         wall_shield,

#         axe,
#         blade_mace,
#         curvy_dagger,
#         dual_axe,
#         katana,
#         long_dagger,
#         rough_sword,
#         short_sword,
#         spiked_stick,
#         wavy_dagger,
#         wooden_hammer,
#     ]
# )

image player_portrait = ConditionSwitch(
    "_last_say_who == 'hiro'", "player_portrait_1",
    "not _last_say_who == 'hiro'", "player_portrait_2")

image jolie_portrait = ConditionSwitch(
    "_last_say_who == 'jol'", "jolie_portrait_1",
    "not _last_say_who == 'jol'", "jolie_portrait_2")

image thora_portrait = ConditionSwitch(
    "_last_say_who == 'tho'", "thora_portrait_1",
    "not _last_say_who == 'tho'", "thora_portrait_2")

image laria_portrait = ConditionSwitch(
    "_last_say_who == 'lar'", "laria_portrait_1",
    "not _last_say_who == 'lar'", "laria_portrait_2")

image chiharu_portrait = ConditionSwitch(
    "_last_say_who == 'chi'", "chiharu_portrait_1",
    "not _last_say_who == 'chi'", "chiharu_portrait_2")





screen hud():
    style_prefix "hud"
    fixed:
        xysize 1920,307 yalign 1.0
        add "hud"

        hbox: #-------------Player
            xalign 0.0 spacing 0
            fixed:
                add hero.portrait
                add "portrait_frame"
            vbox:
                spacing 4 yalign 1.0 yoffset -40
                text hero.name
                fixed:
                    bar value hero.hp range hero.max_hp xysize 260,36 right_bar "bar_empty" left_bar "bar_hp"
                    text "[hero.hp]/[hero.max_hp]"
                fixed:
                    bar value hero.food range hero.max_food xysize 260,36 right_bar "bar_empty" left_bar "bar_food"
                    text "[hero.food]/[hero.max_food]"
                fixed:
                    bar value hero.exp range 100 xysize 260,36 right_bar "bar_empty" left_bar "bar_exp"
                    text "level [hero.level]"
            vbox:
                spacing 4 yalign 1.0 offset 10,-40
                hbox:
                    spacing 4
                    add "rpg/attack.png"
                    text "[hero.total_attack]"
                hbox:
                    spacing 4
                    add "rpg/armor.png"
                    text "[hero.total_armor]"
                hbox:
                    spacing 4
                    add "rpg/cash.png"
                    text "[hero.cash]"

        hbox: #-------------enemy
            xalign 1.0 spacing 0
            vbox:
                spacing 4 yalign 1.0 offset -10,-40
                hbox:
                    spacing 4
                    text "[talking_to.total_attack]"
                    add "rpg/attack.png"
                hbox:
                    spacing 4
                    text "[talking_to.total_armor]"
                    add "rpg/armor.png"
                hbox:
                    spacing 4
                    text "[talking_to.cash]"
                    add "rpg/cash.png"
            vbox:
                spacing 4 yalign 1.0 yoffset -40
                text talking_to.name
                fixed:
                    bar value talking_to.hp range talking_to.max_hp xysize 260,36 right_bar "bar_empty" left_bar "bar_hp"
                    text "[talking_to.hp]/[talking_to.max_hp]"
                fixed:
                    bar value talking_to.food range talking_to.max_food xysize 260,36 right_bar "bar_empty" left_bar "bar_food"
                    text "[talking_to.food]/[talking_to.max_food]"
                fixed:
                    bar value talking_to.exp range 100 xysize 260,36 right_bar "bar_empty" left_bar "bar_exp"
                    text "level [talking_to.level]"
            fixed:
                add talking_to.portrait
                add "portrait_frame"
        add "item_back" align .502,1.0 at items_pos(bool(renpy.get_screen("say"))*300)
        vbox: #-------------items
            at items_pos(bool(renpy.get_screen("say"))*300)
            align .5,1.0 yoffset -20 spacing 8
            hbox:
                spacing 8
                for i in ["left hand", "fingers", "head", "neck", "right hand"]:
                    button:
                        background None padding 0,0
                        action Function(hero.get_filtered_items, i)
                        if len(player.equipment[i]):
                            tooltip player.equipment[i][0]
                        else:
                            tooltip i
                        fixed:
                            add "item_frame"
                            if len(player.equipment[i]):
                                add player.equipment[i][0].icon at zoom(2)
                            else:
                                add "{}_icon".format(i) at zoom(2)

            hbox:
                spacing 8
                for i in ["fingers", "feet", "chest"]:
                    button:
                        background None padding 0,0
                        action Function(hero.get_filtered_items, i)
                        if len(player.equipment[i]):
                            tooltip player.equipment[i][0]
                        else:
                            tooltip i
                        fixed:
                            add "item_frame"
                            if len(player.equipment[i]):
                                add player.equipment[i][0].icon at zoom(2)
                            else:
                                add "{}_icon".format(i) at zoom(2)
                button:
                    background None padding 0,0
                    # action Function(hero.get_filtered_items, i)
                    tooltip "Quick use"
                    fixed:
                        add "item_frame"
                button:
                    background None padding 0,0
                    action Show("open_bag")
                    tooltip "Open bag"
                    fixed:
                        add "item_frame"
                        add "backpack_icon" at zoom(2)
        add "chat_back" align .502,1.0 at items_pos(bool(not renpy.get_screen("say"))*300)


transform items_pos(y):
    ease .2 yoffset y

screen select_item(items, inv, filter):
    modal True
    button:
        background "#000a"
        action Hide("select_item") keysym 'K_ESCAPE'

    frame:
        align .5,1.0 yoffset -250 background "#000a"
        hbox:
            box_wrap True spacing 4 box_wrap_spacing 4
            for i in items:
                button: # Item
                    xysize 68,68 padding 0,0 background "item_frame"
                    action Function(inv.item_equip, i.item, filter), Hide("select_item")
                    tooltip i
                    fixed:
                        add i.item.icon
                        if i.quantity > 1:
                            text str(i.quantity) size 22 align 1.0,1.0

            if len(items) == 0:
                text "You have no item for that." color "#fe0"

style hud_text:
    align (.5,.5)
    size 22
    color "#000"
    font "fonts/Hardpixel.OTF"
style hud_fixed:
    fit_first True
init python:
    config.overlay_screens.append("hud")


screen open_bag():
    modal True
    default mode = "use"
    button:
        background "#000a"
        action Hide("open_bag") keysym 'K_ESCAPE'
    frame:
        align .5,1.0 yoffset -250 background "#000a" xsize 1000
        vbox:
            hbox:
                button:
                    text _("Use")
                    action SetScreenVariable("mode", "use")
                button:
                    text _("Discard")
                    action SetScreenVariable("mode", "discard")
                button:
                    text _("Close")
                    action Hide("open_bag")
            hbox:
                box_wrap True spacing 4 box_wrap_spacing 4
                for i in hero.items:
                    button: # Item
                        xysize 68,68 padding 0,0 background "item_frame"
                        if i != None:
                            if mode == "use":
                                action Function(use_item, i)
                            elif mode == "discard":
                                action Function(hero.drop, True, i.item, i.quantity)
                            tooltip i
                            fixed:
                                add i.item.icon
                                if i.quantity > 1:
                                    text str(i.quantity) size 22 align 1.0,1.0 color "#fff"
    vbox:
        align .0,.5
        text _("Recent items:") color "#ddd"
        text hero.recent_items() color "#ddd"

init python:
    def use_item(item):
        if isinstance(item.item, food):
            hero.food += item.item.food
            if hero.food > hero.max_food:
                hero.food = hero.max_food
            hero.drop(False, item.item, 1)

init python:  # Gift giving
    def get_heros_items():
        items = []
        for i in hero.items:
            if i:
                items.append(i)
        return items
screen choose_a_gift(items = get_heros_items()):
    modal True
    button:
        background "#000a"
        action Return(False) keysym 'K_ESCAPE'

    frame:
        align .5,1.0 yoffset -250 background "#000a"
        hbox:
            box_wrap True spacing 4 box_wrap_spacing 4
            for i in items:
                button: # Item
                    xysize 68,68 padding 0,0 background "item_frame"
                    action Return(i)
                    tooltip i
                    fixed:
                        add i.item.icon
                        if i.quantity > 1:
                            text str(i.quantity) size 22 align 1.0,1.0

            if len(items) == 0:
                text "You have no items to give." color "#fe0"
