﻿init python:
    def create_animations(name, type = "enemy"):
        img = "rpg/{}/{}/sheet.png".format(type, name)
        
        # Down
        c1 = Crop((0, 0, 32, 32), img)
        c2 = Crop((32, 0, 32, 32), img)
        c3 = Crop((64, 0, 32, 32), img)

        # Left
        c4 = Crop((0, 32, 32, 32), img)
        c5 = Crop((32, 32, 32, 32), img)
        c6 = Crop((64, 32, 32, 32), img)

        # Right
        c7 = Crop((0, 64, 32, 32), img)
        c8 = Crop((32, 64, 32, 32), img)
        c9 = Crop((64, 64, 32, 32), img)

        # Up
        c10 = Crop((0, 96, 32, 32), img)
        c11 = Crop((32, 96, 32, 32), img)
        c12 = Crop((64, 96, 32, 32), img)

        # Dead
        dead_1 = Crop((0, 128, 32, 32), img)
        dead_2 = Crop((32, 128, 32, 32), img)

        # attack
        a1 = Crop((96, 0, 32, 32), img)
        a2 = Crop((96, 32, 32, 32), img)
        a3 = Crop((96, 64, 32, 32), img)
        a4 = Crop((96, 96, 32, 32), img)

        # idle
        n = "{} down idle".format(name)
        renpy.image(n, c2)

        n = "{} up idle".format(name)
        renpy.image(n, c11)
        
        n = "{} left idle".format(name)
        renpy.image(n, c5)

        n = "{} right idle".format(name)
        renpy.image(n, c8)

        # attack
        n = "{} down attack".format(name)
        d = Animation([c1, a1, c3, c3], .1)
        renpy.image(n, d)

        n = "{} up attack".format(name)
        d = Animation([c10, a4, c12, c12], .1)
        renpy.image(n, d)
        
        n = "{} left attack".format(name)
        d = Animation([c4, a2, c6, c6], .1)
        renpy.image(n, d)

        n = "{} right attack".format(name)
        d = Animation([c7, a3, c9, c9], .1)
        renpy.image(n, d)



        # Walk
        n = "{} down walk".format(name)
        d = Animation([c1, c2, c3, c2], .1)
        renpy.image(n, d)

        n = "{} up walk".format(name)
        d = Animation([c10, c11, c12, c11], .1)
        renpy.image(n, d)

        n = "{} left walk".format(name)
        d = Animation([c4, c5, c6, c5], .1)
        renpy.image(n, d)

        n = "{} right walk".format(name)
        d = Animation([c7, c8, c9, c8], .1)
        renpy.image(n, d)

        # Dead
        n = "{} down dead".format(name)
        renpy.image(n, dead_1)
        n = "{} up dead".format(name)
        renpy.image(n, dead_2)
        n = "{} left dead".format(name)
        renpy.image(n, dead_1)
        n = "{} right dead".format(name)
        renpy.image(n, dead_2)
        
        return img

    # credits to hell_oh_world and Alex on lemmasoft for helping me figure out this part
    def animation(st, at, frames=[], interval=None):
        frame_count = len(frames)
        if interval is None:
            interval = 1 / float(frame_count)
        return frames[int((st // interval) % frame_count)], interval

    def Animation(frames, interval=0.08):
        return DynamicDisplayable(animation, frames=frames, interval=interval)


#---------------------------------------- Hero
define hiro_sheet = create_animations("Hiro", "npc")
default hiro = Character("Hiro")
default player = player_unit(
    "Hiro",
    0,0,
    0,
    "player_portrait"
)
default hero = player
default nobody = player_unit(
    "",
    0,0,

)
default talking_to = nobody
#---------------------------------------- NPC
define laria_sheet = create_animations("Laria", "npc")
default laria = npc_unit(
    "Laria",
    0,0,
    2,
    "laria_portrait"
)
define jolie_sheet = create_animations("Jolie", "npc")
default jolie = npc_unit(
    "Jolie",
    0,0,
    2,
    "jolie_portrait"
)

define thora_sheet = create_animations("Thora", "npc")
default thora = npc_unit(
    "Thora",
    0,0,
    5,
    "thora_portrait"
)

define chiharu_sheet = create_animations("Chiharu", "npc")
default chiharu = npc_unit(
    "Chiharu",
    0,0,
    5,
    "chiharu_portrait"
)

#---------------------------------------- Enemy
define demon_sheet = create_animations("Demon")
default demon = enemy_unit(
    "Demon",
    0,0,
    table = [
        [spiky_fruit, 15],
        [raw_meat, 5],

        [curvy_dagger, 1],
        [scythe, 1],
        [wall_shield, 1],
        [steel_chestplate, 1],
        [rain_collector_helmet, 1],

        [None, 50]
    ]
)

define donkwolf_sheet = create_animations("Donkwolf")
default donkwolf = enemy_unit(
    "Donkwolf",
    0,0,
    table = [
        [fizzy_drink, 14],
        [bread, 4],

        [hatchet, 1],
        [wooden_hammer, 1],
        [round_shield, 1],
        [bronze_chestplate, 1],
        [golden_helmet, 1],

        [None, 44]
    ]
)

define cycbaby_sheet = create_animations("Cycbaby")
default cycbaby = enemy_unit(
    "Cycbaby",
    0,0,
    table = [
        [spiked_stick, 4],
        [engraved_helmet, 1],
        [cheese, 14],
        [bread, 6],
        [vintage_wine, 1],
        [cinnamon_roll, 1],

        [None, 67]
    ]
)

define goblaze_sheet = create_animations("Goblaze")
default goblaze = enemy_unit(
    "Goblaze",
    0,0,
    table = [
        [blade_mace, 1],
        [dual_axe, 1],
        [wall_shield, 1],
        [engraved_chestplate, 1],
        [royal_helmet, 1],
        [half_gloves, 1],
        [iron_shoes, 1],
        [spiky_fruit, 4],
        [bread, 6],
        [liquor, 6],
        [turnover, 5],

        [None, 78]
    ]
)

define pigug_sheet = create_animations("Pigug")
default pigug = enemy_unit(
    "Pigug",
    0,0,
    table = [
        [hatchet, 1],
        [long_dagger, 1],
        [round_shield, 1],
        [bronze_chestplate, 1],
        [rusty_helmet, 1],
        [raw_meat, 8],
        [spiky_fruit, 10],

        [None, 40]
    ]
)


define kuroshi_sheet = create_animations("Kuroshi")
default kuroshi = enemy_unit(
    "Kuroshi",
    0,0,
    table = [
        [long_dagger, 1],
        [short_sword, 1],
        [leather_shoes, 2],
        [medicine, 13],
        [cinnamon_roll, 6],

        [None, 61]
    ]
)

define succubus_sheet = create_animations("Succubus")
default succubus = enemy_unit(
    "Succubus",
    0,0,
    table = [
        [moon_cake, 5],
        [golden_gloves, 1],
        [horny_hood, 2],
        [None, 40]
    ]
)

define foxmask_sheet = create_animations("Foxmask")
default foxmask = enemy_unit(
    "Foxmask",
    0,0,
    table = [

        [katana, 2],
        [sun_shield, 1],
        [ancient_armor, 1],
        [fizzy_drink, 6],
        [turnover, 4],

        [None, 40]
    ]
)

define genie_sheet = create_animations("Genie")
default genie = enemy_unit(
    "Genie",
    0,0,
    table = [
        [wavy_dagger, 1],
        [wooden_hammer, 1],
        [rough_sword, 1],
        [dual_lion_shield, 1],
        [sun_shield, 1],
        [iron_chestplate, 1],
        [golden_helmet, 1],
        [bronze_helmet, 1],
        [royal_gloves, 1],
        [spiky_fruit, 4],
        [raw_meat, 4],
        [vintage_wine, 12],
        [turnover, 4],

        [None, 40]
    ]
)




default all_enemies = [
    donkwolf, demon, cycbaby, goblaze, pigug,
    kuroshi, succubus, foxmask, genie
    ]
#---------------------------------------- Levels
# default old_levels = load_tiles("labyrinth ground", 32, 8, 8)
# default jolies_room = room_class(
#     _("Small room"),
#     32,
#     [old_levels, "rpg/levels/jolies_room.csv"],
#     0,
#     objects = [[1, 5, spiked_stick]],
#     exits = [[4, 0, "the_well", 1, "down"]],
#     npc = [
#         [jolie, 3, 5],
#     ]
# )
# default the_well = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/the_well.csv"],
#     1,
#     objects = [
#         [17, 4, bronze_chestplate],
#         [3, 3, wood],
#         [3, 3, wood],
#         [3, 3, wood],
#         [11, 4, pick_one(all_plants)],
#         [26, 7, pick_one(all_plants)],
#         [8, 5, pick_one(all_plants)],
#         ],
#     exits = [
#         [24, 9, "jolies_room", 1, "up"],
#         [3, 0, "corridor_3", 2, "down"]
#         ],
#     enemies = [[renpy.random.choice(all_enemies), 18, 3]]
# )
# default corridor_3 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/corridor_3.csv"],
#     1,
#     objects = [
#         [1, 5, pick_one(all_plants)],
#         [9, 4, pick_one(all_plants)],
#         ],
#     exits = [
#         [20, 8, "the_well", 2, "up"],
#         [20, 4, "level_2", 3, "down"],
#         [2, 7, "level_5", 5, "up"],
#         [9, 0, "corridor_5", 4, "down"],
#         [3, 3, "half_half", 38, "down"],
#         ],
#     enemies = [[renpy.random.choice(all_enemies), 2, 5]]
# )
# default level_2 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_2.csv"],
#     1,
#     objects = [
#         [25, 9, half_gloves],
#         [9, 1, barrel],
#         [10, 1, barrel],
#         [8, 2, barrel],
#         [11, 8, old_cauldron],
#         [13, 10,  pick_one(all_plants)],
#         ],
#     exits = [
#         [2, 7, "corridor_3", 3, "up"],
#         [25, 1, "corridor_1", 9, "down"],
#         ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 2, 1],
#         [renpy.random.choice(all_enemies), 25, 8],
#         ]
# )
# default level_5 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_5.csv"],
#     1,
#     objects = [
#         [15, 7, iron_shoes],
#         [25, 10,  pick_one(all_plants)],
#         [19, 6,  pick_one(all_plants)],
#         [12, 2,  pick_one(all_plants)],
#         [2, 4,  pick_one(all_plants)],
#         [12, 5,  pick_one(all_plants)],
#         ],
#     exits = [
#         [23, 0, "corridor_3", 5, "down"],
#         [19, 1, "corridor_4", 6, "down"],
#         [15, 0, "corridor_4", 7, "down"],
#         [7, 1, "corridor_4", 8, "down"],
#         [17, 11, "level_19", 36, "up"],
#         ],
#     npc = [
#         [thora, 22, 4],
#     ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 5, 5],
#         [renpy.random.choice(all_enemies), 22, 5, 0],
#         [renpy.random.choice(all_enemies), 24, 4, 0],
#         [renpy.random.choice(all_enemies), 23, 5, 0],
#     ]
# )
# default corridor_4 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/corridor_4.csv"],
#     0,
#     objects = [
#         [8, 8,  pick_one(all_plants)],
#         ],
#     exits = [
#         [13, 10, "level_5", 6, "up"],
#         [9, 9, "level_5", 7, "up"],
#         [1, 10, "level_5", 8, "up"],
#         ],
# )
# default corridor_5 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/corridor_5.csv"],
#     0,
#     objects = [
#         [2, 5,  pick_one(all_plants)],
#         ],
#     exits = [
#         [4, 11, "corridor_3", 4, "up"],
#         [6, 1, "corridor_2", 12, "down"],
#         ],
# )
# default corridor_1 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/corridor_1.csv"],
#     1,
#     exits = [
#         [3, 9, "level_2", 9, "up"],
#         [1, 0, "level_3", 10, "down"],
#         ],
#     enemies = [[renpy.random.choice(all_enemies), 1, 3]]
# )
# default level_3 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_3.csv"],
#     1,
#     objects = [
#         [22, 2,  pick_one(all_plants)],
#         ],
#     exits = [
#         [3, 10, "corridor_1", 10, "up"],
#         [25, 10, "level_4", 11, "up"],
#         [13, 3, "level_10", 25, "down"],
#         ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 13, 5],
#         [renpy.random.choice(all_enemies), 18, 4],
#         ]
# )
# default level_4 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_4.csv"],
#     1,
#     objects = [
#         [2, 6, bronze_helmet],
#         [26, 2, royal_helmet],
#         [10, 4,  pick_one(all_plants)],
#         [26, 8,  pick_one(all_plants)],
#         ],
#     exits = [
#         [2, 0, "level_3", 11, "down"],
#         [20, 4, "room_2", 42, "down"],
#         [25, 10, "room_4", 43, "up"],
#         ],
# )
# default corridor_2 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/corridor_2.csv"],
#     1,
#     exits = [
#         [7, 4, "corridor_5", 12, "up"],
#         [18, 0, "twin_corridors", 13, "down"],
#         ],
#     enemies = [[renpy.random.choice(all_enemies), 1, 2]]
# )
# default twin_corridors = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/twin_corridors.csv"],
#     3,
#     objects = [
#         [21, 6,  pick_one(all_plants)],
#         ],
#     exits = [
#         [7, 11, "corridor_2", 13, "up"],
#         [9, 0, "big_hall", 15, "down"],
#         [6, 0, "big_hall", 14, "down"],
#         [12, 0, "big_hall", 16, "down"],
#         [15, 0, "big_hall", 17, "down"],
#         [13, 9, "level_6", 18, "up"],
#         [20, 2, "level_9", 22, "down"],
#         [2, 4, "level_12", 26, "up"],
#         ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 13, 7],
#         [renpy.random.choice(all_enemies), 2, 2],
#         ]
# )
# default big_hall = room_class(
#     _("Big hall"),
#     32,
#     [old_levels, "rpg/levels/big_hall.csv"],
#     10,
#     objects = [
#         [3, 5,  pick_one(all_plants)],
#         [23, 3,  pick_one(all_plants)],
#         [23, 3,  tree_trunk],
#         ],
#     exits = [
#         [12, 11, "twin_corridors", 15, "up"],
#         [9, 11, "twin_corridors", 14, "up"],
#         [15, 11, "twin_corridors", 16, "up"],
#         [18, 11, "twin_corridors", 17, "up"],
#         ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 4, 7],
#         [renpy.random.choice(all_enemies), 14, 3],
#         [renpy.random.choice(all_enemies), 21, 6],
#         [renpy.random.choice(all_enemies), 24, 2]],
# )

# default level_6 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_6.csv"],
#     1,
#     objects = [],
#     exits = [
#         [4, 0, "twin_corridors", 18, "down"],
#         [14, 10, "level_8", 19, "up"],
#         [2, 9, "level_7", 20, "down"],
#         ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 9, 9],
#         ]
# )
# default level_8 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_8.csv"],
#     1,
#     objects = [],
#     exits = [
#         [2, 0, "level_6", 19, "down"],
#         ],
#     enemies = [
#         [renpy.random.choice(all_enemies), 2, 3],
#         ]
# )
# default level_7 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_7.csv"],
#     1,
#     objects = [],
#     exits = [
#         [12, 2, "level_6", 20, "up"],
#         [2, 7, "level_11", 21, "up"],
#         ],
#     enemies = [
#         ]
# )

# default level_11 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_11.csv"],
#     1,
#     objects = [],
#     exits = [
#         [4, 0, "level_7", 21, "down"],
#         ],
#     enemies = [
#         ]
# )

# default level_9 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_9.csv"],
#     4,
#     objects = [],
#     exits = [
#         [2, 7, "twin_corridors", 22, "up"],
#         # [10, 0, "twin_corridors", 23, "down"],
#         [13, 6, "level_10", 24, "up"],
#         ],
#     enemies = [
#         ]
# )
# default level_10 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_10.csv"],
#     1,
#     objects = [],
#     exits = [
#         [1, 4, "level_9", 24, "down"],
#         [6, 9, "level_3", 25, "up"],
#         [17, 2, "room_1", 39, "up"],
#         ],
#     enemies = [
#         ]
# )

# default level_12 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_12.csv"],
#     0,
#     objects = [],
#     exits = [
#         [8, 2, "twin_corridors", 26, "down"],
#         [2, 0, "level_13", 27, "down"],
#         ],
#     enemies = [
#         ]
# )

# default level_13 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_13.csv"],
#     1,
#     objects = [],
#     exits = [
#         [12, 3, "level_12", 27, "up"],
#         [7, 8, "level_14", 28, "up"],
#         # [2, 2, "level_3", 29, "down"],
#         [2, 5, "level_15", 30, "up"],
#         ],
#     enemies = [
#         ]
# )
# default level_14 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_14.csv"],
#     1,
#     objects = [],
#     exits = [
#         [2, 0, "level_13", 28, "down"],
#         ],
#     enemies = [
#         ]
# )

# default level_15 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_15.csv"],
#     1,
#     objects = [],
#     exits = [
#         [11, 0, "level_13", 30, "down"],
#         [2, 11, "level_16", 31, "up"],
#         ],
#     enemies = [
#         ]
# )

# default level_16 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_16.csv"],
#     1,
#     objects = [],
#     exits = [
#         [11, 0, "level_15", 31, "down"],
#         [20, 6, "half_half", 32, "up"],
#         [2, 11, "level_17", 33, "up"],
#         ],
#     enemies = [
#         ]
# )

# default half_half = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/half_half.csv"],
#     1,
#     objects = [],
#     npc = [
#         [chiharu, 5, 1],
#     ],
#     exits = [
#         [2, 0, "level_16", 32, "down"],
#         [4, 6, "corridor_3", 38, "up"],
#         ],
#     enemies = [
#         ]
# )
# default level_17 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_17.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [9, 0, "level_16", 33, "down"],
#         [2, 11, "level_18", 34, "up"],
#         ],
#     enemies = [
#         ]
# )
# default level_18 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_18.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [2, 0, "level_17", 34, "down"],
#         [5, 7, "level_19", 35, "up"],
#         ],
#     enemies = [
#         ]
# )
# default level_19 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/level_19.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [2, 1, "level_18", 35, "down"],
#         [19, 0, "level_5", 36, "down"],
#         # [19, 2, "level_5", 37, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_1 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_1.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [3, 0, "level_10", 39, "down"],
#         [16, 8, "room_2", 40, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_2 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_2.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [11, 0, "room_1", 40, "down"],
#         [4, 2, "room_3", 41, "up"],
#         [17, 9, "level_4", 42, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_3 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_3.csv"],
#     0,
#     objects = [],
#     npc = [
#         [laria, 8, 3],
#     ],
#     exits = [
#         [2, 0, "room_2", 41, "down"],
#         ],
#     enemies = [
#         ]
# )
# default room_4 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_4.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [21, 4, "level_4", 43, "down"],
#         # [16, 7, "level_4", 44, "up"],
#         [2, 5, "room_6", 45, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_6 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_6.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [21, 8, "room_4", 45, "down"],
#         [11, 9, "room_7", 46, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_7 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_7.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [11, 2, "room_6", 46, "down"],
#         [11, 5, "room_8", 47, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_8 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_8.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [2, 2, "room_7", 47, "down"],
#         [2, 5, "room_9", 48, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_9 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_9.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [11, 2, "room_8", 48, "down"],
#         [11, 5, "room_10", 50, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_10 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_10.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [2, 2, "room_9", 50, "down"],
#         [2, 5, "room_11", 51, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_11 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_11.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [11, 2, "room_10", 51, "down"],
#         [11, 5, "room_12", 52, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_12 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_12.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [2, 2, "room_11", 52, "down"],
#         [2, 5, "room_13", 53, "up"],
#         ],
#     enemies = [
#         ]
# )
# default room_13 = room_class(
#     _("Room"),
#     32,
#     [old_levels, "rpg/levels/room_13.csv"],
#     1,
#     objects = [],
#     npc = [
#     ],
#     exits = [
#         [19, 3, "room_12", 53, "down"],
#         # [2, 7, "room_13", 54, "up"],
#         ],
#     enemies = [
#         ]
# )


# label level_1:
#     $ nobody.hp = 0
#     $ nobody.food = 0
#     $ nobody.max_hp = 1
#     $ nobody.max_food = 1
#     $ nobody.total_attack = 0
#     $ nobody.total_armor = 0
#     $ hero.add_item([bread, 3])

#     $ hero.food = 95
#     $ hero.hp = 90

#     $ thora.hp = 14
#     $ thora.food = 86

#     $ chiharu.direction = "left"

#     $ laria.direction = "up"

#     show screen level_change(corridor_3, corridor_3.exits[0])
#     pause 1.2
#     "{w=.5}{nw}"
#     $ hero.direction = "left"
#     "{w=.5}{nw}"
#     $ hero.direction = "right"
#     "{w=.5}{nw}"
#     $ hero.direction = "down"
#     hiro "Yep"
#     hiro "I'm lost!"
#     window hide











