﻿#---------------------------------------- Levels
default dungeon_new_collisions = range(-1,34)
default dungeon_new = load_tiles("dungeon new", 32, 4, 18)
default outside = room_class(
    _("Outside"),
    32,
    dungeon_new,
    "rpg/new levels/outside.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    0,
    exits = [
        [1, 1, "entrance", "a2-1", "down"],
        [1, 1, "entrance", "a2-2", "down"],
    ],
)
default entrance = room_class(
    _("Entrance"),
    32,
    dungeon_new,
    "rpg/new levels/entrance.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    0,
    exits = [
        [3, 2, "entrance_hall", "a1-1", "down"],
        [4, 2, "entrance_hall", "a1-2", "down"],

        [3, 7, "outside", "a2-1", "up"],
        [4, 7, "outside", "a2-2", "up"],
    ],
    breakables = [
        [terracotta_vase, 3, 3],
        [terracotta_vase, 4, 3],
        [short_terracotta_vase, 5, 3],
    ],
)
default entrance_hall = room_class(
    _("Entrance hall"),
    32,
    dungeon_new,
    "rpg/new levels/entrance_hall.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    1,
    exits = [
        [5, 11, "entrance", "a1-1", "up"],
        [6, 11, "entrance", "a1-2", "up"],

        [5, 2, "royal_corridor", "b1-1", "down"],
        [6, 2, "royal_corridor", "b1-2", "down"],

        [11, 6, "servants_wing", "c1-1", "left"],
        [11, 7, "servants_wing", "c1-2", "left"],

        [0, 6, "military_wing", "d1-1", "right"],
        [0, 7, "military_wing", "d1-2", "right"],
    ],
    breakables = [
        [terracotta_vase, 2, 3],
        [terracotta_vase, 9, 3],
    ],
)
#--------------------------------------------- Royal wing
default royal_corridor = room_class(
    _("The royal corridor"),
    32,
    dungeon_new,
    "rpg/new levels/royal_corridor.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    4,
    exits = [
        [2, 11, "entrance_hall", "b1-1", "up"],
        [3, 11, "entrance_hall", "b1-2", "up"],

        [2, 2, "throne_room", "b2-1", "down"],
        [3, 2, "throne_room", "b2-2", "down"],
    ],
    breakables = [
        [green_vase, 1, 3],
        [green_vase, 4, 3],
        [green_vase, 1, 6],
        [green_vase, 4, 6],
        [green_vase, 1, 9],
        [green_vase, 4, 9],
        
    ],
)
default throne_room = room_class(
    _("Throne room"),
    32,
    dungeon_new,
    "rpg/new levels/throne_room.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    0,
    exits = [
        [10, 11, "royal_corridor", "b2-1", "up"],
        [11, 11, "royal_corridor", "b2-2", "up"],
    ],
        npc = [
        [jolie, 10, 6],
    ],
    objects = [
        [5, 7, stick],
    ],
)


#--------------------------------------------- servant's wing
default servants_wing = room_class(
    _("Servant's wing"),
    32,
    dungeon_new,
    "rpg/new levels/servants_wing.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    2,
    exits = [
        [0, 5, "entrance_hall", "c1-1", "right"],
        [0, 6, "entrance_hall", "c1-2", "right"],

        [4, 8, "servants_room", "c2", "up"],
        # [5, 2, "servants_room", "c3", "down"],
        [7, 3, "kitchen", "c4", "left"],
    ],
    breakables = [
        [short_terracotta_vase, 2, 3],
        [short_terracotta_vase, 3, 3],
        [short_terracotta_vase, 1, 7],
        [blue_vase, 6, 6],
    ],
)
default servants_room = room_class(
    _("Servant's room"),
    32,
    dungeon_new,
    "rpg/new levels/servants_room.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    2,
    exits = [
        [5, 2, "servants_wing", "c2", "down"],
    ],
)
default kitchen = room_class(
    _("Kitchen"),
    32,
    dungeon_new,
    "rpg/new levels/kitchen.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    3,
    exits = [
        [0, 5, "servants_wing", "c4", "right"],
        [19, 6, "pantry", "c5", "left"],
    ],
)
default pantry = room_class(
    _("Pantry"),
    32,
    dungeon_new,
    "rpg/new levels/pantry.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    3,
    exits = [
        [0, 7, "kitchen", "c5", "right"],
    ],
)
#--------------------------------------------- Military wing
default military_wing = room_class(
    _("Military wing"),
    32,
    dungeon_new,
    "rpg/new levels/military_wing.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    3,
    exits = [
        [11, 7, "entrance_hall", "d1-1", "left"],
        [11, 8, "entrance_hall", "d1-2", "left"],
        
        [4, 2, "royal_guards_residence", "d2", "down"],
        [0, 4, "armory_barracks_fork", "d3", "right"],
    ],
)
default royal_guards_residence = room_class(
    _("Military wing"),
    32,
    dungeon_new,
    "rpg/new levels/royal_guards_residence.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    3,
    exits = [
        [18, 11, "military_wing", "d2", "up"],
    ],
)
default armory_barracks_fork = room_class(
    _("Armory - Barracks"),
    32,
    dungeon_new,
    "rpg/new levels/armory_barracks_fork.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    0,
    exits = [
        [13, 5, "military_wing", "d3", "left"],
        [0, 4, "armory", "d4", "right"],
        [6, 9, "barracks", "d5", "up"],
    ],
)
default armory = room_class(
    _("Armory"),
    32,
    dungeon_new,
    "rpg/new levels/armory.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    12,
    exits = [
        [20, 6, "armory_barracks_fork", "d4", "left"],
    ],
)
default barracks = room_class(
    _("Barracks"),
    32,
    dungeon_new,
    "rpg/new levels/barracks.csv",
    dungeon_new_collisions,
    [20, 22, 31, 35, 43, 46, 47],
    4,
    exits = [
        [17, 2, "armory_barracks_fork", "d5", "down"],
        # [22, 4, "armory_barracks_fork", "d6", "left"],
    ],
    npc = [
        [thora, 17, 8],
    ],
    enemies = [
        [renpy.random.choice(all_enemies), 17, 9, 0],
        [renpy.random.choice(all_enemies), 18, 8, 0],
        [renpy.random.choice(all_enemies), 18, 9, 0],
    ]
)

label level_new:
    $ nobody.hp = 0
    $ nobody.food = 0
    $ nobody.max_hp = 1
    $ nobody.max_food = 1
    $ nobody.total_attack = 0
    $ nobody.total_armor = 0
    $ hero.add_item([bread, 3])

    $ hero.food = 95
    $ hero.hp = 15

    $ thora.hp = 14
    $ thora.food = 86

    $ chiharu.direction = "left"

    $ laria.direction = "up"
    $ jolie.direction = "up"

    show screen level_change(entrance, outside.exits[0], True)
    pause 1.2
    "{w=.5}{nw}"
    $ hero.direction = "down"
    $ entrance.walk(hero, "up", True)
    "{w=.5}{nw}"
    hiro "Fuck!"
    hiro "What was that?!"
    window hide
    jump game_loop










